# -*- coding:Utf-8 -*-
#-------------------------------------------------------------------------------
# Name:        sorrow.py
#
# Author:      sKy
#
# Created:     08/07/2008
#-------------------------------------------------------------------------------

## Module EventScripts/Python
import es, sqlite3, langlib, popuplib, playerlib

## Module propriétaire
import module.sw_player as swPlayer # Module sw_player
import module.sw_config as swConfig # Module sw_config
import module.sw_ghoster as swGhoster # Module sw_ghoster
import module.sw_weapon as swWeapon # Module sw_weapon
import module.sw_admin as swAdmin # Module sw_admin

## Rend public les informations du scripts
info = es.AddonInfo()
info.name = "sorrow"
info.version = "2.0"
info.author = "sKy"
info.url = "http://mattie.info/forums/"
info.description = "Fun Mod for Trikz, Bhop & xp map"
info.tags = "bhop;trikz;xc;sky;ssk;sorrow"
es.ServerVar("Sorrow_version", info.version).makepublic()

sw_maptype = "" # Contient le type de la map en cours

## Ouverture du fichier de langue
sw_langue = langlib.Strings(es.getAddonPath("sorrow") + "/configuration/langues.ini")

def config():
    """Run when script load or when map change"""
    global sw_maptype
    # Je récupere le préfix de la map (de, cs, etc)
    _currentMap = str(es.ServerVar('eventscripts_currentmap'))
    _maptype = _currentMap.split("_")
    sw_maptype = _maptype[0]

def load():
    """Run when script is running"""
    config() # Charge le maptype
    createSorrowMenu() # Créer le menu principale utilisable avec !swmenu
    ## Commandes du script
    es.regsaycmd("!ghost", "sorrow/GhostCmd", "[Sorrow] Met le joueur Ghost/UnGhost.")
    es.regclientcmd("!ghost", "sorrow/GhostCmd", "[Sorrow] Met le joueur Ghost/UnGhost.")
    es.regsaycmd("!ghoster", "sorrow/GhosterCmd", "[Sorrow] Envoi un menu au joueur pour se mettre Ghost/Unghost.")
    es.regclientcmd("!ghoster", "sorrow/GhosterCmd", "[Sorrow] Envoi un menu au joueur pour se mettre Ghost/Unghost.")
    es.regsaycmd("!weapon", "sorrow/WeaponCmd", "[Sorrow] Envoi le menu des armes au joueur.")
    es.regclientcmd("!weapon", "sorrow/WeaponCmd", "[Sorrow] Envoi le menu des armes au joueur.")
    es.regsaycmd("!swmenu", "sorrow/SorrowCmd", "[Sorrow] Envoi le menu principale au joueur.")
    es.regclientcmd("!swmenu", "sorrow/SorrowCmd", "[Sorrow] Envoi le menu principale au joueur.")
    es.regsaycmd("!swadmin", "sorrow/AdminCmd", "[Sorrow] Envoi le menu admin au joueur.")
    es.regclientcmd("!swadmin", "sorrow/AdminCmd", "[Sorrow] Envoi le menu admin au joueur.")
    
def unload():
    """Run when script unload"""
    # Supression des commandes
    es.unregsaycmd("!ghost")
    es.unregclientcmd("!ghost")
    es.unregsaycmd("!ghoster")
    es.unregclientcmd("!ghoster")
    es.unregsaycmd("!weapon")
    es.unregclientcmd("!weapon")
    es.unregsaycmd("!swmenu")
    es.unregclientcmd("!swmenu")
    es.unregsaycmd("!swadmin")
    es.unregclientcmd("!swadmin")
    
def es_map_start(event_var):
    """Run when map is start"""
    config() # Charge le maptype
    
def player_spawn(event_var):
    """Run when player spawn"""
    player = swPlayer.Player(event_var["userid"]) # instantiation pour récupéré les informations du joueurs grace au module player
    level = player.get("level") # Level du joueur
    xp = player.get("xp") # Nombre d'xp du joueur
    config = swConfig.Config("modules") # Je récupére les configs du fichier modules.ini
    map_on = config.get("ModuleGhoster", str(es.ServerVar('eventscripts_currentmap'))) # Vérifie si le module ghoster est actif sur ce type de map
    if map_on == False or map_on == 0:
        maptype_on = config.get("ModuleGhoster", sw_maptype)
        if maptype_on == False or maptype_on == 0:
            ghost_level = config.get("ModuleGhoster", "ghost_level")
        else:
            ghost_level = config.get(sw_maptype, "ghost_level")
    else:
        module = swConfig.Config("modules")
        ghost_level = module.get(str(es.ServerVar('eventscripts_currentmap')), "ghost_level")
    if int(level) >= ghost_level:
        ghoster = swGhoster.Ghost(event_var["userid"])
        ghoster.ghost()
    msg = {}
    msg["level"] = level
    msg["xp"] = xp
    joueur = playerlib.getPlayer(event_var["userid"])
    if config.get("ModuleGod", str(es.ServerVar('eventscripts_currentmap'))) == "god":
        es.server.cmd("est_god %s 1"%(event_var["userid"]))
    elif config.get("ModuleGod", str(es.ServerVar('eventscripts_currentmap'))) == "hp":
        joueur = playerlib.getPlayer(event_var["userid"])
        joueur.set("health", config.get("ModuleGod", "Health_to_give"))
    elif config.get("ModuleGod", sw_maptype) == "god":
        es.server.cmd("est_god %s 1"%(event_var["userid"]))
    elif config.get("ModuleGod", sw_maptype) == "hp":
        joueur = playerlib.getPlayer(event_var["userid"])
        joueur.set("health", config.get("ModuleGod", "Health_to_give"))
    #es.tell(event_var["userid"],"#multi",sw_langue("spawn",opts=msg,lang=joueur.get("lang")))
    
def player_activate(event_var):
    """Run when player is activate on the server"""
    player = swPlayer.Player(event_var["userid"])
    onDatabase = player.get("onDatabase") # Vérifie si le joueur est dans la base de donnée
    if onDatabase == False:
        player.create() # Sinon on l'ajoute
    
def player_death(event_var):
    es.server.cmd("est_deleteragdolls") # suprime les corps au sol
    
def player_blind(event_var):
    es.server.cmd("es_fadevolume %s 100 0 2.5 0"%(event_var["userid"])) # enleve le son d'une flash
    joueur = playerlib.getPlayer(event_var["userid"]) # instantiation du joueur
    joueur.set("flash", [ "0", "0" ]) # suprime le blind créer par le flash
    
def GhostCmd():
    """Run when player use "!ghost" command"""
    userid = es.getcmduserid() # récupére l'userid de celui qui tape la commande
    joueur = swPlayer.Player(userid) # instantiation du joueur
    level = joueur.get("level") # récupére son level
    isghost = joueur.get("isghost") # vérifie si il est déjà en mode "ghost" (si on peu passé à travers le joueur ou pas)
    config = swConfig.Config("modules") # récupération des configurations du fichier modules.ini
    if isghost != True:
        ghost_level = config.get("ModuleGhoster", "ghost_level") # si il n'est pas ghost on récupére son level
        if int(ghost_level) <= int(level):
            ghoster = swGhoster.Ghost(userid) # si il a le level on le met ghost
            ghoster.ghost()
        else:
            joueur = playerlib.getPlayer(event_var["userid"]) # Sinon on lui envoi un message
            es.tell(self.userid,"#multi",sw_langue("ghost_not_level",lang=joueur.get("lang")))
    else:
        unghost_level = config.get("ModuleGhoster", "unghost_level") # Si il est ghost on le met unghost si il a le level
        if int(unghost_level) <= int(level):
            ghoster = swGhoster.Ghost(userid)
            ghoster.unghost()
        else:
            joueur = playerlib.getPlayer(event_var["userid"]) # si il n'a pas le level on lui envoi un message
            es.tell(self.userid,"#multi",sw_langue("unghost_not_level",lang=joueur.get("lang")))

def GhosterCmd():
    """Run when player use "!ghoster" command"""
    userid = es.getcmduserid() # récupération de l'userid de celui qui tape la commande
    ghost = swGhoster.Ghost(userid) # instantiation du joueur dans le module ghost pour lui envoyer le menu
    ghost.send_menu() # envoi du menu

def WeaponCmd():
    """Run when player use "!weapon" command"""
    userid = es.getcmduserid() # récupération de l'userid de celui qui tape la commande
    weapon = swWeapon.Weapon(userid) # instantiation du joueur dans le module weapon pour lui envoyer le menu
    weapon.send_menu() # envoi du menu
   
def SorrowCmd():
    """Run when player use "!swmenu" command"""
    userid = es.getcmduserid() # récupération de l'userid de celui qui tape la commande
    popuplib.send("menuSorrow", userid) # Envoi du menu sorrow
    
def createSorrowMenu():
    """Create sorrow menu"""
    menu = popuplib.create('menuSorrow')
    menu.addline("(______[Sorrow]______)")
    menu.addline("->1. Ghoster")
    menu.addline("->2. Weapon")
    menu.addline("------------------")
    menu.addline("[   Sorrow v2.0   ]")
    menu.addline("[     By sKy`       ]")
    menu.addline("------------------")
    menu.addline("->0. Sortir")
    menu.menuselect = choixMenuSorrow
    
def choixMenuSorrow(userid, choix, popupid):
    ghost = swGhoster.Ghost(userid)
    weapon = swWeapon.Weapon(userid)
    if choix == 1:
        ghost.send_menu() # Choix 1 on lui envoi le menu du module ghost
    elif choix == 2:
        weapon.send_menu() # Choix 2 on lui envoi le menu du module weapon

def AdminCmd():
    userid = es.getcmduserid() # récupération de l'userid
    player = swPlayer.Player(userid) # instantiation du joueur pour savoir si il est admin
    isadmin = player.get("isadmin")
    if isadmin == True:
        admin = swAdmin.Admin(userid) # si oui, on lui envoi le menu
        admin.sendMenu()
    else:
        joueur = playerlib.getPlayer(event_var["userid"]) # sinon on lui envoi un message
        es.tell(self.userid,"#multi",sw_langue("not_admin",lang=joueur.get("lang")))